$(function() {
    $("#dropzone").on("dragenter", highlight);
    $("#dropzone").on("dragover", highlight);
    $("#dropzone").on("dragleave", unhighlight);
    $("#dropzone").on("drop", handleDrop);
    $("#dropzone input[type=file]").on("click", function(e) {
      e.stopPropagation();
    });
    $("#dropzone input[type=file]").on("change", handleSelect);
    $("#dropzone").on("click", function() {
      $("#dropzone input[type=file]").trigger('click');
    });
});

function highlight(e) {
    e.preventDefault();
    e.stopPropagation();
    $("#dropzone").addClass("drop-active");
}

function unhighlight(e) {
    e.preventDefault();
    e.stopPropagation();
    $("#dropzone").removeClass("drop-active");
}

function handleDrop(e) {
    e.preventDefault();
    e.stopPropagation();
    ([...e.originalEvent.dataTransfer.files]).forEach(uploadFile);
}

function handleSelect(e) {
  $("#dropzone").addClass("drop-uploading");
  ([...e.currentTarget.files]).forEach(uploadFile);
}

function uploadFile(file) {
    $("#dropzone").addClass("drop-uploading");
    let formData = new FormData();

    formData.append('document', file);
    formData.append('printer', $("#printer").val());

    fetch("/", {
        method: 'POST',
        body: formData
    })
    .then(function() { info("File " + file.name + " sent to printer."); })
    .catch(function() { error("An error occured while sending " + file.name + " to printer.") })

}

function info(text) {
  $("#dropzone").removeClass("drop-uploading");
  $("#dropzone").removeClass("drop-active");
  var element = $('<div class="alert alert-success alert-dismissible fade show">' + text + '<button type="button" class="close" data-dismiss="alert" aria-label="Close"> <span aria-hidden="true">&times;</span> </button></div>');
  $("#messages").append(element)
  setTimeout(function() { element.alert('close'); }, 3000);
}

function error(text) {
  $("#dropzone").removeClass("drop-uploading");
  $("#dropzone").removeClass("drop-active");
  var element = $('<div class="alert alert-danger alert-dismissible fade show">' + text + '<button type="button" class="close" data-dismiss="alert" aria-label="Close"> <span aria-hidden="true">&times;</span> </button></div>');
  $("#messages").append(element)
}
